/*
 * ļ:          DelOtherFile.java
 * Ȩ@ 2001-2003 пƼ޹˾Ȩ
 * :           JDK1.5.0_01
 * ʱ:             17:12:07
 */

package common.appsole;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.net.URL;
import java.net.URLClassLoader;

import common.data.DisposeData;
import common.data.I18nResource;
import common.data.SharedAttr;
import common.util.IoHelper;
import common.util.Log;
import common.util.OsVersion;
import common.util.ParseIniFile;

/**
 * TODO: ļע
 * <p>
 * <p>
 * EIO汾: EIO Office V1.3
 * <p>
 * : User387()
 * <p>
 * : 2006-2-14
 * <p>
 * : User387()
 * <p>
 * С: INL
 * <p>
 * <p>
 */
public class DelEioOtherFile
{
    /**
     * 
     * @param idata
     */
    public static void delFile(DisposeData idata)
    {
        String installedPath = idata.getInstallPath();
        I18nResource langpack = idata.langpackMap;
        int appType = idata.localInfo.getAppType();
        try
        {
            //жEIOReader
            if (appType == SharedAttr.EIOREADER)
            {
                File delFile = new File(installedPath.concat(File.separator).concat("System"));
                if (delFile.exists())
                {
                    IoHelper.deltree(delFile, null);
                }
                //
                delFile = new File(installedPath.concat(File.separator).concat("Config"));
                if (delFile.exists())
                {
                    IoHelper.deltree(delFile, null);
                }
                delFile = new File(System.getProperty("user.home").concat(File.separator).concat(
                    "EIOffice").concat(File.separator).concat("UserConfig").concat(File.separator)
                    .concat("eioReaderSystem.dll"));
                if (delFile.exists())
                {
                    IoHelper.deltree(delFile, null);
                }
                delFile = new File(System.getProperty("user.home").concat(File.separator).concat(
                    "EIOffice").concat(File.separator).concat("UserConfig").concat(File.separator)
                    .concat("BarData_EIOReader"));
                if (delFile.exists())
                {
                    IoHelper.deltree(delFile, null);
                }
                if (OsVersion.IS_LINUX)
                {
                    delFile = new File("/usr/share/EIOReaderIcon");
                    if (delFile.exists())
                    {
                        IoHelper.deltree(delFile, null);
                    }
                    delFile = new File("/etc/Evermore/EIOReader");
                    if (delFile.exists())
                    {
                        IoHelper.deltree(delFile, null);
                    }
                    String[] eioReaderApplnk = {
                        "/usr/share/applnk/" + langpack.getString("uninstaller.applnk.info"),
                        "/usr/share/applnk/Vendor_menus/"
                            + langpack.getString("uninstaller.applnk.info"),
                        "/var/lib/menu/kde/Applications/"
                            + langpack.getString("uninstaller.applnk.info")};
                    for (int i = 0; i < eioReaderApplnk.length; i++)
                    {
                        delFile = new File(eioReaderApplnk[i]);
                        if (delFile.exists())
                        {
                            IoHelper.deltree(delFile, null);
                        }
                    }
                }
            }
            //жEIOffice
            else if (appType == SharedAttr.EIOFFICE || appType == SharedAttr.EIOPERSON)
            {
                delMultiuserCreateFile(installedPath);
                //delete PatchFiles of windows or linux
                File delFile = new File(installedPath.concat(File.separator).concat("System")
                    .concat(File.separator).concat("unpatch.ini"));
                if (delFile.exists())
                {
                    deletePatchFiles(installedPath);
                }

                delFile = new File(installedPath.concat(File.separator).concat("patcheio.log"));
                if (delFile.exists())
                {
                    IoHelper.deltree(delFile, null);
                }

                //delete 1.24eio installPath/system dir
                delFile = new File(installedPath.concat(File.separator).concat("system"));
                if (delFile.exists())
                {
                    IoHelper.deltree(delFile, null);
                }
                delteCommonDir(installedPath);
                if (OsVersion.IS_WINDOWS)
                {
                    delFile = new File(System.getProperty("user.home").concat(File.separator)
                        .concat("Application Data").concat(File.separator).concat("EIOffice")
                        .concat(File.separator).concat("UserConfig").concat(File.separator).concat(
                            "BarData"));
                    if (delFile.exists())
                    {
                        IoHelper.deltree(delFile, null);
                    }

                    delFile = new File(System.getProperty("user.home").concat(File.separator)
                        .concat("Application Data").concat(File.separator).concat("EIOffice")
                        .concat(File.separator).concat("UserConfig").concat(File.separator).concat(
                            "eiosystem.dll"));
                    if (delFile.exists())
                    {
                        IoHelper.deltree(delFile, null);
                    }

                    delFile = new File(System.getProperty("user.home").concat(File.separator)
                        .concat("Application Data").concat(File.separator).concat("EIOffice")
                        .concat(File.separator).concat("DefaultTemplate"));
                    if (delFile.exists())
                    {
                        IoHelper.deltree(delFile, null);
                    }
                }
                else
                {
                    // delete EIOffice userconfig directory files
                    delFile = new File(System.getProperty("user.home").concat(File.separator)
                        .concat("EIOffice").concat(File.separator).concat("UserConfig").concat(
                            File.separator).concat("BarData"));
                    if (delFile.exists())
                    {
                        IoHelper.deltree(delFile, null);

                    }

                    delFile = new File(System.getProperty("user.home").concat(File.separator)
                        .concat("EIOffice").concat(File.separator).concat("UserConfig").concat(
                            File.separator).concat("eiosystem.dll"));
                    if (delFile.exists())
                    {
                        IoHelper.deltree(delFile, null);
                    }

                    delFile = new File(installedPath.concat(File.separator).concat("Upgrade"));
                    if (delFile.exists())
                    {
                        IoHelper.deltree(delFile, null);
                    }

                    delFile = new File(System.getProperty("user.home").concat(File.separator)
                        .concat("EIOffice").concat(File.separator).concat("DefaultTemplate"));
                    if (delFile.exists())
                    {
                        IoHelper.deltree(delFile, null);
                    }

                    //delete eiofileicon
                    delFile = new File("/usr/share/eiofileicon");
                    if (delFile.exists())
                    {
                        IoHelper.deltree(delFile, null);
                    }
                    delFile = new File("/usr/share/pixmaps/uninstalleio");
                    if (delFile.exists())
                    {
                        IoHelper.deltree(delFile, null);
                    }
                    delFile = new File("/root/.kde/share/applnk/.hidden/EIOffice.desktop");
                    if (delFile.exists())
                    {
                        IoHelper.deltree(delFile, null);
                    }
                    String[] applnk = {
                        "/usr/share/applnk/" + langpack.getString("uninstaller.applnk.info"),
                        "/usr/share/applnk/Vendor_menus/"
                            + langpack.getString("uninstaller.applnk.info"),
                        "/var/lib/menu/kde/Applications/"
                            + langpack.getString("uninstaller.applnk.info")};
                    for (int i = 0; i < applnk.length; i++)
                    {
                        delFile = new File(applnk[i]);
                        if (delFile.exists())
                        {
                            IoHelper.deltree(delFile, null);
                        }
                    }
                    handleMenuPref(appType);
                    delFile = new File("/etc/Evermore/EIOffice");
                    if (delFile.exists())
                    {
                        IoHelper.deltree(delFile, null);
                    }
                }
                //debug 318462
                delFile = new File(installedPath.concat(File.separator).concat("EIOffice.jar"));
                if (delFile.exists())
                {
                    delFile.delete();
                }
            }
            else
            //ScienceStar
            {
                delteCommonDir(installedPath);
                File delFile = new File(System.getProperty("user.home").concat(File.separator)
                    .concat("Science").concat(File.separator).concat("UserConfig").concat(
                        File.separator).concat("BarData"));
                if (delFile.exists())
                {
                    IoHelper.deltree(delFile, null);
                }
                delFile = new File(System.getProperty("user.home").concat(File.separator).concat(
                    "Science").concat(File.separator).concat("UserConfig").concat(File.separator)
                    .concat("eiosystem.dll"));
                if (delFile.exists())
                {
                    IoHelper.deltree(delFile, null);
                }

                delFile = new File(installedPath.concat(File.separator).concat("Upgrade"));
                if (delFile.exists())
                {
                    IoHelper.deltree(delFile, null);
                }

                delFile = new File(System.getProperty("user.home").concat(File.separator).concat(
                    "Science").concat(File.separator).concat("DefaultTemplate"));
                if (delFile.exists())
                {
                    IoHelper.deltree(delFile, null);
                }

                delFile = new File("/usr/share/sciencestaricon");
                if (delFile.exists())
                {
                    IoHelper.deltree(delFile, null);
                }
                handleMenuPref(appType);
                delFile = new File("/etc/Evermore/ScienceStar");
                if (delFile.exists())
                {
                    IoHelper.deltree(delFile, null);
                }
                delFile = new File(installedPath.concat(File.separator).concat("ScienceStar.jar"));
                if (delFile.exists())
                {
                    delFile.delete();
                }
            }

            if (OsVersion.IS_LINUX)//,һвƷ,ɾ
            {
                File delFile = new File("/etc/Evermore");
                if (delFile.isDirectory() && delFile.list().length == 0)
                {
                    delFile.delete();
                    delFile = new File("/usr/X11R6/lib/X11/fonts/TrueType");
                    IoHelper.deltree(delFile, null);
                }
            }
        }
        catch(Exception e)
        {
            Log.writelog(e);
        }
    }

    /**
     * жʱɾEIOfficeScienceStarͬһЩĿ¼
     * @param installedPath
     */
    private static void delteCommonDir(String installedPath)
    {
        try
        {
            //delete 1.31eio installPath/System dir
            File systemDir = new File(installedPath.concat(File.separator).concat("System"));
            if (systemDir.exists())
            {
                IoHelper.deltree(systemDir, null);
            }
            //delete 1.31eio installPath/Config dir
            File configDir = new File(installedPath.concat(File.separator).concat("Config"));
            if (configDir.exists())
            {
                IoHelper.deltree(configDir, null);
            }
            //ɾʹÿƽزĺļ
            File scienceEditorImages = new File(installedPath.concat(File.separator).concat(
                "ScienceEditorImages").concat(File.separator).concat("logicalData"));
            if (scienceEditorImages.exists())
            {
                IoHelper.deltree(scienceEditorImages, null);
            }
            //eio2009ûĿ¼CustomizedSEImages
            File customizeImage = new File(System.getProperty("user.home").concat(File.separator)
                .concat("EIOffice").concat(File.separator).concat("CustomizedSEImages"));
            if (customizeImage.exists())
            {
                IoHelper.deltree(customizeImage, null);
            }
        }
        catch(Exception e)
        {
            Log.writelog(e);
        }
    }

    private static void deletePatchFiles(String installedPath)
    {
        try
        {
            ParseIniFile parseFile = new ParseIniFile(installedPath.concat(File.separator).concat(
                "System").concat(File.separator)
                + "unpatch.ini", ParseIniFile.NO_CHARSET);
            parseFile.readIniFile();
            String patchFilesSize = parseFile.getValue("files", "file_count");
            for (int i = 1; i <= Integer.parseInt(patchFilesSize); i++)
            {
                File patchFile = new File(parseFile.getValue("files", "file" + i));
                if (patchFile.exists())
                {
                    IoHelper.deltree(patchFile, null);
                }
            }
        }
        catch(Exception e)
        {
            Log.writelog(e.getMessage());
        }
    }

    private static void delMultiuserCreateFile(String installedPath) throws Exception
    {
        String line;
        File file = new File(installedPath.concat(File.separator).concat("System").concat(
            File.separator).concat("appdata"));
        if (file.exists())
        {
            BufferedReader br = new BufferedReader(new FileReader(file));
            while ((line = br.readLine()) != null)
            {
                File normalFile = new File(line.concat(File.separator).concat("DefaultTemplate")
                    .concat(File.separator).concat("EIONormal.eit"));
                if (normalFile.exists())
                    normalFile.delete();

                File BarData = new File(line.concat(File.separator).concat("UserConfig").concat(
                    File.separator).concat("BarData"));
                if (BarData.exists())
                    IoHelper.deltree(BarData, null);

                File eiosystemdll = new File(line.concat(File.separator).concat("UserConfig")
                    .concat(File.separator).concat("eiosystem.dll"));
                if (eiosystemdll.exists())
                    IoHelper.deltree(eiosystemdll, null);

                File eioDesktop = new File(line.substring(0, line.lastIndexOf(File.separator))
                    .concat(File.separator).concat("Desktop").concat(File.separator).concat(
                        "EIOffice"));
                if (eioDesktop.exists())
                    eioDesktop.delete();
            }
            br.close();
        }
    }

    /**
     * жʱGnomeһЩͼ
     * @param installedPath
     */
    public static void handleGnomePref(DisposeData idata)
    {
        if (idata.localInfo.getAppType() == SharedAttr.SCIENCESTAR)
        {
            ScienceStarAssociate.uninstallLink();
        }
        else
        {
            try
            {
                String clName = "file:".concat(idata.getInstallPath().concat(
                    "/Mimelnk/fileAssociate.jar"));
                URLClassLoader cl = new URLClassLoader(new URL[]{new URL(clName)});
                java.lang.reflect.Method method = cl.loadClass("FileAssociate").getMethod(
                    "uninstallLink", new Class[]{String.class});
                method.invoke("uninstallLink", new Object[]{idata.getInstallPath()});
            }
            catch(Exception ex)
            {
                Log.writelog("uninstalling when invoking FileAssociate, yield exception");
            }
        }
    }

    /**
     * жʱһЩ˵йصļ
     */
    private static void handleMenuPref(int appType)
    {
        if (appType == SharedAttr.SCIENCESTAR)
        {
            //applications.menu
            File app = new File("/etc/xdg/menus/applications-merged/sciencestar.menu");
            if (app.exists())
            {
                app.delete();
            }
            app = new File("/usr/share/desktop-directories/sciencestar.directory");
            if (app.exists())
            {
                app.delete();
            }
        }
        else
        {
            //for redhat8,9
            File app = new File("/usr/share/applnk-redhat/Office/eio.desktop");
            if (app.exists())
            {
                app.delete();
            }
            app = new File("/usr/share/applnk-redhat/Office/eiouninstall.desktop");
            if (app.exists())
            {
                app.delete();
            }
            app = new File("/usr/share/applnk-redhat/Office/eiofileconvert.desktop");
            if (app.exists())
            {
                app.delete();
            }
            //for redflag5
            app = new File("/etc/xdg/menus/applications-merged/eioffice.menu");
            if (app.exists())
            {
                app.delete();
            }
            app = new File("/usr/share/desktop-directories/eioffice.directory");
            if (app.exists())
            {
                app.delete();
            }
        }
    }

    /**
     * ɾݷʽ
     * @param idata DisposeData
     */
    public static void handleDesktopLink(DisposeData idata)
    {
        //for desktopShortcutLink        
        //String desk = IoHelper.getDesktop();
        int count = -1;
        boolean isScienceStar = false;
        int appType = idata.localInfo.getAppType();
        if (appType == SharedAttr.EIOPERSON)
        {
            count = 6;
        }
        else if (appType == SharedAttr.EIOFFICE)
        {
            count = 5;
        }
        else if (appType == SharedAttr.SCIENCESTAR)
        {
            count = 5;
            isScienceStar = true;
        }
        //reader
        if (count > 0)
        {
            String line = null;
            try
            {
                BufferedReader in = new BufferedReader(new FileReader(isScienceStar
                    ? "/etc/Evermore/ScienceStar/installinfo.cfg"
                    : "/etc/Evermore/EIOffice/installinfo.cfg"));
                while (count-- > 0 && (line = in.readLine()) != null)
                {
                }
            }
            catch(FileNotFoundException ex)
            {
                Log.writelog("create FileNotFoundException, when del desktopShortCut.");
            }
            catch(IOException ex)
            {
                Log.writelog("create IOException, when del desktopShortCut.");
            }
            if (count == -1 && line != null)
            {
                File app = new File(line.trim().concat(
                    isScienceStar ? "/sciencestar.desktop" : "/eio.desktop"));
                if (app.exists())
                {
                    app.delete();
                }
            }
        }
    }
}