/*
 * ļ:          PreFinishConfig
 * Ȩ@ 2001-2003 пƼ޹˾Ȩ
 * :           JDK1.5.0_01
 * ʱ:             18:39:16
 */

package common.appsole;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.lang.reflect.Method;
import java.net.URL;
import java.net.URLClassLoader;
import java.text.NumberFormat;
import java.util.HashMap;
import java.util.Random;

import common.data.DisposeData;
import common.data.Info;
import common.data.SharedAttr;
import common.system.ShellLink;
import common.util.FileExecutor;
import common.util.IoHelper;
import common.util.Log;
import common.util.OsVersion;
import common.util.ScriptParser;

import emo.inl.eioxpack.dispose.ShortcutCreator;

/**
 * 
 * <p>
 * ǰEIOļԼ΢ļjre дעȵ÷Ĳ
 * <p>
 * EIO汾: EIO Office V1.3
 * <p>
 * : gxf
 * <p>
 * : 2006-2-13
 * <p>
 * : gxf
 * <p>
 * С: INL
 * <p>
 * <p>
 */
public class PreFinishConfig
{
    private DisposeData idata;

    private boolean msCheckSelected;
    private boolean rtfCheckSelected;
    private boolean shortcutCheckSelected;

    private String desktop;//û·
    private String installPath;//EIOװ·
    private int appType;//װ

    public PreFinishConfig(DisposeData idata)
    {
        this.idata = idata;
        installPath = idata.getInstallPath();
        appType = idata.localInfo.getAppType();

        //GUIװ
        if (idata.getGuiPrefs() != null)
        {
            //bidi棬OptionPanelеõûmslinkshortcutѡ
            if (!this.idata.getGuiPrefs().isBidiGui)
            {
                this.msCheckSelected = idata.msCheckSelected;
                this.rtfCheckSelected = idata.rtfCheckSelected;
                this.shortcutCheckSelected = idata.shortcutsCheckSelected;
            }
            //bidi棬OptionPanelеõûmslinkѡshortcutĬΪtrue
            else
            {
                this.msCheckSelected = idata.msCheckSelected;
                this.rtfCheckSelected = idata.rtfCheckSelected;
                this.shortcutCheckSelected = true;
            }
        }
        //Ĭװ
        else
        {
            this.msCheckSelected = true;
            this.rtfCheckSelected = true;
            this.shortcutCheckSelected = true;
        }
    }

    public void doPreFinishConfig()
    {
        createShortcuts();

        // bidiע
        if (OsVersion.IS_WINDOWS && idata.getGuiPrefs().isBidiGui)
        {
            configBidiFonts(true);
            setBidiSystemLinkFont();
        }

        if (appType == SharedAttr.EIOFFICE || appType == SharedAttr.EIOPERSON)
        {
            // plugin
            JrePluginConfig jpc = new JrePluginConfig(idata);
            if (OsVersion.IS_LINUX)
            {
                jpc.configPluginLinux();
            }
            if (OsVersion.IS_WINDOWS)
            {
                String command = DisposeData.getCurrentPath().concat(File.separator).concat(
                    ShellLink.NATIVE).concat(File.separator);
                jpc.configPluginWin(true, command.concat(ShellLink.PLUGIN_EXE));
            }
        }

        replaceStrForCups();
        if (appType == SharedAttr.SCIENCESTAR)//ƽ֮ļ
        {
            ScienceStarAssociate.installLink();
        }
        else
        {
            //ļ
            fileLink();
        }
    }

    public void installinfo(DisposeData idata)
    {
        if (!OsVersion.IS_WINDOWS)
        {
            Info info = idata.info;
            HashMap map = (HashMap)info.getInstallInfoMap();
            String infoFileName = "";
            String installpathFileName124 = "/usr/share/installpath";

            // get installinfo file name
            if (info.getAppVersion().equals("1.24"))
                infoFileName = (String)map.get("1.24Linux");
            else
                infoFileName = (String)map.get("1.31Linux");

            if (infoFileName == null)
            {
                Log.writelog("ConfigInstallerListener.afterPacks, " + "infoFileName of "
                    + OsVersion.OS_NAME + "not found from installInfoMap");
            }
            File infoFile = new File(infoFileName);

            String parentPath = infoFile.getParent();

            if (parentPath == null)
            {
                System.out.println(infoFile.getPath() + "===null,create it");
                return;
            }
            File pFile = new File(parentPath);
            if (!pFile.exists())
            {
                if (!pFile.mkdirs())
                {
                    System.out.println(infoFile.getPath() + "create failed");
                    return;
                }
            }
            try
            {
                if (info.getAppVersion().equals("1.24"))
                {
                    Log.writelog("write 1.24 installinfo.");
                    // 1.24,write installpath
                    FileWriter fwPath = new FileWriter(installpathFileName124);
                    fwPath.write(installPath);
                    fwPath.flush();
                    fwPath.close();
                }
                else
                {
                    Log.writelog("write 1.3 installinfo.cfg." + "EIOffice installpath :"
                        + installPath + " EIOffice Version : " + idata.getAppVersion());
                    FileWriter fwInfo = new FileWriter(infoFile);
                    //һУװ·
                    fwInfo.write(installPath);
                    fwInfo.write("\n");
                    //ڶУ汾
                    fwInfo.write(idata.getAppVersion());
                    fwInfo.write("\n");
                    //УGUID·
                    fwInfo.write(idata.localInfo.getEioXpackGuidPath());
                    fwInfo.write("\n");
                    //УװԴ·installSourceάģʽλװԴ
                    fwInfo.write(DisposeData.getCurrentPath());
                    //eio˰棬Ӹ˱ʶ                    
                    if (appType == SharedAttr.EIOPERSON)
                    {
                        fwInfo.write("\n");
                        fwInfo.write(this.buildPersonTag());
                    }
                    if (desktop != null)
                    {
                        fwInfo.write("\n");
                        fwInfo.write(desktop);
                    }
                    fwInfo.flush();
                    fwInfo.close();
                }
            }
            catch(Exception e)
            {
                Log.writelog(e.getMessage());
            }
        }
        else
        {
            // windows,עд밲װϢ
            ILocalInfo linfo = idata.localInfo;
            if (!linfo.setRegInfo())
                Log.writelog("writeEvermoreReg error!");
        }
    }

    /**
     *ڰ汾patchжʱûɾEIOKey.store     
     *Ժװʱcdkeyʹeio
     */
    public void delCDKeyFile()
    {
        try
        {
            File f = new File(installPath.concat(File.separator).concat("Config").concat(
                File.separator).concat("EIOKey.store"));
            if (f.exists())
                f.delete();
            File BarData = new File(System.getProperty("user.home").concat(File.separator).concat(
                "EIOffice").concat(File.separator).concat("UserConfig").concat(File.separator)
                .concat("BarData"));
            if (BarData.exists())
            {
                IoHelper.deltree(BarData, null);
            }
            File eiosystemDll = new File(System.getProperty("user.home").concat(File.separator)
                .concat("EIOffice").concat(File.separator).concat("UserConfig").concat(
                    File.separator).concat("eiosystem.dll"));
            if (eiosystemDll.exists())
            {
                IoHelper.deltree(eiosystemDll, null);
            }
        }
        catch(Exception e)
        {
            Log.writelog(e);
        }
    }

    public void propertyInfo(DisposeData idata)
    {
        File file;
        if (!idata.getAppVersion().equals("1.24"))
            // 1.31
            file = new File(installPath.concat(File.separator).concat("Config").concat(
                File.separator).concat("install.property"));
        else
            // 1.24
            file = new File(installPath.concat(File.separator).concat("system").concat(
                File.separator).concat("install.property"));
        String parentPath = file.getParent();
        File pFile = new File(parentPath);
        if (!pFile.exists())
        {
            if (!pFile.mkdirs())
            {
                System.out.println(file.getPath() + "create failed");
                return;
            }
        }
        Log.writelog("write install.property." + " Install path :" + installPath + " User name :"
            + UserConfigInfo.getInstance().getUserName() + " Company name :"
            + UserConfigInfo.getInstance().getCompanyName());
        OutputStreamWriter osw;
        try
        {
            //bidiû˾ʹutf8дļ 
            if (OsVersion.IS_WINDOWS)
                osw = new OutputStreamWriter(new FileOutputStream(file), "utf-8");
            else
                osw = new OutputStreamWriter(new FileOutputStream(file));

            osw.write(installPath);
            osw.write("\n");
            if (idata.getAppVersion().equals("1.24"))
            {
                osw.write("/EIO_Binders");
                osw.write("\n");
            }
            if (appType == SharedAttr.EIOPERSON)
            {
                osw.write("evermore");
                osw.write("\n");
                osw.write("evermore");
            }
            else
            {
                osw.write(UserConfigInfo.getInstance().getUserName());
                osw.write("\n");
                osw.write(UserConfigInfo.getInstance().getCompanyName());
            }
            osw.flush();
            osw.close();
        }
        catch(IOException e)
        {
            Log.writelog(e);
        }
    }

    public void eniInfo(DisposeData idata)
    {
        try
        {
            String currentPath = DisposeData.getCurrentPath();
            File src = new File(currentPath.concat(File.separator).concat("config.eni"));
            File dest;
            if (src.exists())
            {
                dest = new File(installPath.concat(File.separator).concat("Config").concat(
                    File.separator).concat("config.eni"));
                IoHelper.copyFile(src, dest);
            }

            src = new File(currentPath.concat(File.separator).concat("InstallInfo.ini"));
            if (src.exists())
            {
                dest = new File(installPath.concat(File.separator).concat("Config").concat(
                    File.separator).concat("InstallInfo.ini"));
                IoHelper.copyFile(src, dest);
            }

            Log.writelog("Copy "
                + currentPath.concat(File.separator).concat("InstallInfo.ini")
                + " to "
                + installPath.concat(File.separator).concat("Config").concat(File.separator)
                    .concat("InstallInfo.ini"));
        }
        catch(IOException e)
        {
            Log.writelog(e);
        }
    }

    /**
     * жwindowsļжeioעplugin
     * 
     */
    public void undoPreFinishConfig()
    {
        // жwindowsļжeioע
        fileUnLink();

        // plugin
        JrePluginConfig jpc = new JrePluginConfig(idata);

        if (OsVersion.IS_LINUX)
        {
            jpc.unConfigPlugin();
        }
        if (OsVersion.IS_WINDOWS)
        {
            String command = DisposeData.getCurrentPath().concat(File.separator).concat(
                ShellLink.NATIVE).concat(File.separator);
            jpc.configPluginWin(false, command.concat(ShellLink.PLUGIN_EXE));

            // жbidiע
            if (idata.getGuiPrefs().isBidiGui)
            {
                configBidiFonts(false);
                // setBidiSystemLinkFont();
            }
        }
    }

    /**
     * widnows:ݷʽͿʼ˵Ŀݷʽ
     * ڰװ־жͨװ־С
     * Linux:ڰװShortcutsѾװ
     * desktopCheckSelectedɾݷʽ
     */
    private void createShortcuts()
    {
        Log.writelog("Create shortcuts");
        if (OsVersion.IS_WINDOWS)
        {
            ShortcutCreator sc = new ShortcutCreator(idata);
            sc.doCreateShortcuts();
        }
        else
        {
            OsVersion.initRelease();
            //˵
            if (OsVersion.is_redhat && appType != SharedAttr.SCIENCESTAR)//ûн,ϵͳ鵽""
            {
                try
                {
                    createRedhatLink();
                }
                catch(IOException ex)
                {
                    Log.writelog("when create menu link on redhat linux, yield IOException");
                }
            }
            else if (!new File("/etc/xdg/menus/applications.menu").exists()
                && !new File("/etc/xdg/menus/gnome-applications.menu").exists()
                && !new File("/etc/xdg/menus/kde-applications.menu").exists())
            {
                createMenu();
                createDir();
            }

            //(3)ݼڵǰû
            if (shortcutCheckSelected || appType == SharedAttr.SCIENCESTAR)
            {
                createDeskLink();
            }
        }
    }

    /**
     * redhat8,9Ҫ/usr/share/applicationļӵ/usr/share/applnk-redhat/Office
     * @throws IOException
     */
    private void createRedhatLink() throws IOException
    {
        Runtime.getRuntime().exec(
            "ln -s /usr/share/applications/eio.desktop /usr/share/applnk-redhat/Office/");
        Runtime.getRuntime().exec(
            "ln -s /usr/share/applications/eiouninstall.desktop /usr/share/applnk-redhat/Office/");
        if (new File("/usr/share/applications/eiofileconvert.desktop").exists())
        {
            Runtime
                .getRuntime()
                .exec(
                    "ln -s /usr/share/applications/eiofileconvert.desktop /usr/share/applnk-redhat/Office/");
        }
    }

    private void createMenu()
    {
        StringBuilder sb = new StringBuilder();
        String menuName;
        sb.append("<Menu>" + "\n");
        sb.append("<Name>Applications</Name>" + "\n");
        sb.append("<Menu>" + "\n");
        if (appType == SharedAttr.SCIENCESTAR)
        {
            sb.append("<Name>ScienceStar</Name>" + "\n");
            sb.append("<Directory>sciencestar.directory</Directory>" + "\n");
            sb.append("<Include>" + "\n");
            sb.append("<Filename>sciencestar.desktop</Filename>" + "\n");
            sb.append("<Filename>sciencestar-uninstall.desktop</Filename>" + "\n");
            //            if (true)
            //            {
            //                sb.append("<Filename>eiofileconvert.desktop</Filename>" + "\n");
            //            }
            menuName = "/etc/xdg/menus/applications-merged/sciencestar.menu";
        }
        else if (appType == SharedAttr.EIOREADER)
        {
            /**@todo:EIOReader,֪EIOReader,ܼȥ*/
            menuName = "/etc/xdg/menus/applications-merged/eioreader.menu";
        }
        else
        {
            sb.append("<Name>EIOffice</Name>" + "\n");
            sb.append("<Directory>eioffice.directory</Directory>" + "\n");
            sb.append("<Include>" + "\n");
            sb.append("<Filename>eio.desktop</Filename>" + "\n");
            sb.append("<Filename>eiouninstall.desktop</Filename>" + "\n");
            sb.append("<Filename>eiofileconvert.desktop</Filename>" + "\n");
            menuName = "/etc/xdg/menus/applications-merged/eioffice.menu";
        }
        sb.append("</Include>" + "\n");
        sb.append("</Menu>" + "\n");
        sb.append("</Menu>");
        try
        {
            BufferedWriter out = new BufferedWriter(new FileWriter(menuName));
            out.write(sb.toString());
            out.close();
        }
        catch(IOException ex)
        {
            Log.writelog("when write .menu on redflag linux, yield IOException.");
        }
    }

    private void createDir()
    {
        StringBuilder sb = new StringBuilder();
        String dirName;
        sb.append("[Desktop Entry]" + "\n");
        if (appType == SharedAttr.SCIENCESTAR)
        {
            sb.append("Name=ScienceStar" + "\n");
            sb.append("Name[zh_CN]=".concat(idata.langpackMap.getString("uninstaller.applnk.info"))
                .concat("\n"));
            sb.append("Icon=/usr/share/sciencestaricon/science.png" + "\n");
            dirName = "/usr/share/desktop-directories/sciencestar.directory";
        }
        else if (appType == SharedAttr.EIOREADER)
        {
            /**@todo://EIOReader*/
            dirName = "/usr/share/desktop-directories/eioreader.directory";
        }
        else
        {
            sb.append("Name=EIOffice 2009" + "\n");
            sb.append("Name[zh_CN]=".concat(idata.langpackMap.getString("uninstaller.applnk.info"))
                .concat("\n"));
            sb.append("Icon=/usr/share/eiofileicon/eioicon.png" + "\n");
            dirName = "/usr/share/desktop-directories/eioffice.directory";
        }
        //sb.append("Name[zh_CN]=\u6c38\u4e2d\u96c6\u6210Office\u00202009" + "\n");        
        sb.append("Type=Directory");
        try
        {
            BufferedWriter out = new BufferedWriter(new FileWriter(dirName));
            out.write(sb.toString());
            out.close();
        }
        catch(IOException ex)
        {
            Log.writelog("when write .directory on redflag linux, yield IOException.");
        }
    }

    /**
     * ݷʽ
     */
    private void createDeskLink()
    {
        desktop = IoHelper.getDesktop();
        if (desktop != null)
        {
            try
            {
                String src, target;
                if (appType == SharedAttr.SCIENCESTAR)
                {
                    src = "/System/sciencestar.desktop";
                    target = "/sciencestar.desktop";
                }
                else if (appType == SharedAttr.EIOREADER)
                {
                    src = "/System/eioreader.desktop";
                    target = "/eioreader.desktop";
                }
                else
                {
                    src = "/System/eio.desktop";
                    target = "/eio.desktop";
                }
                IoHelper.copyFile(new File(installPath.concat(src)), new File(desktop
                    .concat(target)), "0775");
            }
            catch(IOException ex)
            {
                Log.writelog("copy $install/System/EIOffice to Desktop, failed!");
            }
        }
    }

    /**
     * ļ
     */
    private void fileLink()
    {
        if (OsVersion.IS_LINUX)
        {
            //ù
            linuxMsFileLink();
            linuxRtfLink();
            //ļ
            replaceStrForFileLink();
        }
        if (OsVersion.IS_WINDOWS)
        {
            String exeCommand;
            exeCommand = DisposeData.getCurrentPath().concat(File.separator).concat(
                ShellLink.NATIVE).concat(File.separator).concat(ShellLink.MS_FILELINK_EXE);
            // ú΢
            windowsMsFileLink(exeCommand);

            String command = DisposeData.getCurrentPath().concat(File.separator).concat(
                ShellLink.NATIVE).concat(File.separator);
            // eioļ
            windowsEioFileLink(true, command.concat(ShellLink.FILELINK_EXE));
        }
    }

    /**
     * жļжeioעlinuxļжDelEIOOtherFile
     */
    private void fileUnLink()
    {
        if (OsVersion.IS_WINDOWS)
        {
            String exeCommand;
            exeCommand = DisposeData.getCurrentPath().concat(File.separator).concat(
                ShellLink.NATIVE).concat(File.separator).concat(ShellLink.MS_FILELINK_EXE);
            // ú΢
            this.msCheckSelected = false;
            windowsMsFileLink(exeCommand);

            String command = DisposeData.getCurrentPath().concat(File.separator).concat(
                ShellLink.NATIVE).concat(File.separator);
            // ãļ
            windowsEioFileLink(false, command.concat(ShellLink.FILELINK_EXE));
        }
    }

    /**
     * linuxϵͳ:ťѡ,installPathSystem/msfilelink.confļ,
     * Իеļϵ.
     * 
     */
    private void linuxMsFileLink()
    {
        if (msCheckSelected)
        {
            String msFileLink;
            if (!idata.info.getAppVersion().equals("1.24"))
            {
                msFileLink = installPath.concat("/System/msfilelink.conf");
            }
            else
            {
                msFileLink = installPath.concat("/system/msfilelink.conf");
            }
            try
            {
                IoHelper.copyFile(IoHelper.getResource("msfilelink.conf"), new FileOutputStream(
                    msFileLink));
                String mimelnkDir, docName, xlsName, pptName, docBakName, xlsBakName, pptBakName, docxName, dotxName, xlsxName, xltxName, pptxName, potxName;
                if (OsVersion.is_suse)
                {
                    mimelnkDir = "/opt/kde3/share/mimelnk/application";
                    docName = "/opt/kde3/share/mimelnk/application/msword.desktop";
                    xlsName = "/opt/kde3/share/mimelnk/application/msexcel.desktop";
                    pptName = "/opt/kde3/share/mimelnk/application/mspowerpoint.desktop";
                    docxName = "/opt/kde3/share/mimelnk/application/vnd.openxmlformats-officedocument.wordprocessingml.document.desktop";
                    xlsxName = "/opt/kde3/share/mimelnk/application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.desktop";
                    pptxName = "/opt/kde3/share/mimelnk/application/vnd.openxmlformats-officedocument.presentationml.presentation.desktop";
                    dotxName = "/opt/kde3/share/mimelnk/application/vnd.openxmlformats-officedocument.wordprocessingml.template.desktop";
                    xltxName = "/opt/kde3/share/mimelnk/application/vnd.openxmlformats-officedocument.spreadsheetml.template.desktop";
                    potxName = "/opt/kde3/share/mimelnk/application/vnd.openxmlformats-officedocument.presentationml.template.desktop";

                }
                else
                {
                    mimelnkDir = "/usr/share/mimelnk/application";
                    docName = "/usr/share/mimelnk/application/msword.desktop";
                    xlsName = "/usr/share/mimelnk/application/msexcel.desktop";
                    pptName = "/usr/share/mimelnk/application/mspowerpoint.desktop";
                    docxName = "/usr/share/mimelnk/application/vnd.openxmlformats-officedocument.wordprocessingml.document.desktop";
                    xlsxName = "/usr/share/mimelnk/application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.desktop";
                    pptxName = "/usr/share/mimelnk/application/vnd.openxmlformats-officedocument.presentationml.presentation.desktop";
                    dotxName = "/usr/share/mimelnk/application/vnd.openxmlformats-officedocument.wordprocessingml.template.desktop";
                    xltxName = "/usr/share/mimelnk/application/vnd.openxmlformats-officedocument.spreadsheetml.template.desktop";
                    potxName = "/usr/share/mimelnk/application/vnd.openxmlformats-officedocument.presentationml.template.desktop";
                }
                docBakName = installPath.concat("/Mimelnk/MimelnkKdeMS/zz-msword.desktop");
                xlsBakName = installPath.concat("/Mimelnk/MimelnkKdeMS/zz-msexcel.desktop");
                pptBakName = installPath.concat("/Mimelnk/MimelnkKdeMS/zz-mspowerpoint.desktop");
                if (new File(mimelnkDir).isDirectory())
                {
                    if (new File(docName).exists())
                    {
                        IoHelper.copyFile(docName, docBakName);
                    }
                    if (new File(xlsName).exists())
                    {
                        IoHelper.copyFile(xlsName, xlsBakName);
                    }
                    if (new File(pptName).exists())
                    {
                        IoHelper.copyFile(pptName, pptBakName);
                    }
                    IoHelper.copyFile(installPath
                        .concat("/Mimelnk/MimelnkKdeMS/mspowerpoint.desktop"), pptName);
                    IoHelper.copyFile(installPath.concat("/Mimelnk/MimelnkKdeMS/msword.desktop"),
                        docName);
                    IoHelper.copyFile(installPath.concat("/Mimelnk/MimelnkKdeMS/msexcel.desktop"),
                        xlsName);
                    IoHelper
                        .copyFile(
                            installPath
                                .concat("/Mimelnk/MimelnkKdeMS/vnd.openxmlformats-officedocument.presentationml.presentation.desktop"),
                            pptxName);
                    IoHelper
                        .copyFile(
                            installPath
                                .concat("/Mimelnk/MimelnkKdeMS/vnd.openxmlformats-officedocument.spreadsheetml.sheet.desktop"),
                            xlsxName);
                    IoHelper
                        .copyFile(
                            installPath
                                .concat("/Mimelnk/MimelnkKdeMS/vnd.openxmlformats-officedocument.wordprocessingml.document.desktop"),
                            docxName);
                    IoHelper
                        .copyFile(
                            installPath
                                .concat("/Mimelnk/MimelnkKdeMS/vnd.openxmlformats-officedocument.wordprocessingml.template.desktop"),
                            dotxName);
                    IoHelper
                        .copyFile(
                            installPath
                                .concat("/Mimelnk/MimelnkKdeMS/vnd.openxmlformats-officedocument.spreadsheetml.template.desktop"),
                            xltxName);
                    IoHelper
                        .copyFile(
                            installPath
                                .concat("/Mimelnk/MimelnkKdeMS/vnd.openxmlformats-officedocument.presentationml.template.desktop"),
                            potxName);
                }
            }
            catch(Exception e)
            {
                Log.writelog(e);
            }
        }
    }

    /**
     * linuxϵͳ:ťѡ,installPathSystem/rtffilelink.confļ,
     * Իеļϵ.
     */
    private void linuxRtfLink()
    {
        if (rtfCheckSelected)
        {
            try
            {
                IoHelper.copyFile(IoHelper.getResource("rtffilelink.conf"), new FileOutputStream(
                    installPath.concat("/System/rtffilelink.conf")));
                String mimelnkDir, rtfName;
                if (OsVersion.is_suse)
                {
                    mimelnkDir = "/opt/kde3/share/mimelnk/text";
                    rtfName = "/opt/kde3/share/mimelnk/text/rtf.desktop";
                }
                else
                {
                    mimelnkDir = "/usr/share/mimelnk/text";
                    rtfName = "/usr/share/mimelnk/text/rtf.desktop";
                }
                if (new File(mimelnkDir).isDirectory())
                {
                    if (new File(rtfName).exists())
                    {
                        IoHelper.copyFile(rtfName, installPath.concat("/Mimelnk/zz-rtf.desktop"));
                    }
                    IoHelper.copyFile(installPath.concat("/Mimelnk/rtf.desktop"), rtfName);
                }
            }
            catch(Exception e)
            {
                Log.writelog(e);
            }
        }
    }

    /**
     * 
     * windowsƽ̨ⲿeioļ װʱǰ·\native\Associate.exe -install
     * ӣļ жسʱãﰲװ·\System\Associate.exe -uninstall жأļ
     * 
     * @param bEioFileLinked:
     *            壺װļ壺ж
     */
    private void windowsEioFileLink(boolean bEioFileLinked, String command)
    {
        String[] output = new String[2];
        FileExecutor fe = new FileExecutor();
        if (bEioFileLinked)
        {
            File commandFile = new File(command);
            if (!commandFile.exists())
            {
                System.out.println(command + " not exists!");
                Log.writelog(command + " not exitst!");
                return;
            }
            String[] installParams = {command, "-install"};
            fe.executeCommand(installParams, output);
        }
        else
        {
            try
            {
                File commandFile = new File(command);
                if (!commandFile.exists())
                {
                    System.out.println(command + " not exists!");
                    Log.writelog(command + " not exitst!");
                    return;
                }
                String[] uninstallParams = {command, "-uninstall"};
                fe.executeCommand(uninstallParams, output);
            }
            catch(Exception e)
            {
                Log.writelog(e.getMessage());
            }
        }
    }

    /**
     * bidiר windowsƽ̨ⲿά"NORWEST Tuz.ttf""Nibrat.ttf"
     * װʱǰ·\native\Associate.exe -installfont
     * жسʱãﰲװ·\System\Associate.exe -uninstallfont Ŀǰֻжأװʹ
     * 
     * @param bEioFileLinked:
     *            壺װ壺ж
     */
    private void configBidiFonts(boolean bInstallFont)
    {
        String command = DisposeData.getCurrentPath().concat(File.separator).concat(
            ShellLink.NATIVE).concat(File.separator).concat(ShellLink.FILELINK_EXE);

        String[] output = new String[2];
        FileExecutor fe = new FileExecutor();

        if (bInstallFont)
        {
            File commandFile = new File(command);
            if (!commandFile.exists())
            {
                System.out.println(command + " not exists!");
                Log.writelog(command + " not exitst!");
                return;
            }

            String[] installParams = {command, "-installfont"};
            fe.executeCommand(installParams, output);
        }
        else
        {
            try
            {
                File commandFile = new File(command);
                if (!commandFile.exists())
                {
                    System.out.println(command + " not exists!");
                    Log.writelog(command + " not exitst!");
                    return;
                }

                String[] uninstallParams = {command, "-uninstallfont"};
                fe.executeCommand(uninstallParams, output);
            }
            catch(Exception e)
            {
                Log.writelog(e.getMessage());
            }
        }
    }

    /**
     * bidiר
     * 
     * fontFileName HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows
     * NT\CurrentVersion\FontLink\SystemLink Tahoma
     * ֵԭֵӵfontFileNameдע ҪΪeioڱ Guiprefжƣȷ:
     * "ļ" + "," + "" άģ NORWEST Tuz ļNORWEST Tuz.ttf String
     * fontFile, String fontName  Nibrat ļNibrat.ttf
     * 
     * @param fontFile
     *            ļ
     * @param fontName
     *             עάĺͰİ棬˷κβ
     * @return:
     */
    private void setBidiSystemLinkFont()
    {
        String fontValue = idata.getGuiPrefs().fontFile.concat(",").concat(
            idata.getGuiPrefs().fontName);

        EIOfficeLocalInfo linfo = (EIOfficeLocalInfo)idata.localInfo;
        if (linfo.getMydll().SetSystemLinkFont(fontValue) == 1)
            Log
                .writelog("Set "
                    + fontValue
                    + " to HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\FontLink\\SystemLink Sucessfully!");
        else
            Log
                .writelog("Set "
                    + fontValue
                    + " to HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\FontLink\\SystemLink failed!");
    }

    /**
     * windowsƽ̨ ⲿú΢ļ EIOMail.exe !!! ȡEIOMail.exe \\\\\\
     * 
     * @param command:EIOMail.exe·
     */
    private void windowsMsFileLink(String command)
    {
        String[] output = new String[2];
        FileExecutor fe = new FileExecutor();
        File commandFile = new File(command);
        if (!commandFile.exists())
        {
            System.out.println(command + " not exists!");
            Log.writelog(command + " not exitst!");
            return;
        }

        if (msCheckSelected)
        {

            String[] installParams = {command, "-SetLink"};
            fe.executeCommand(installParams, output);
        }
        else
        {
            String[] uninstallParams = {command, "-UnLink"};
            fe.executeCommand(uninstallParams, output);

        }
    }

    /**
     * linuxִнű
     * FinishPanel
     */
    public void executeScript()
    {
        if (OsVersion.IS_LINUX)
        {
            try
            {
                File file = new File(DisposeData.getCurrentPath().concat(File.separator).concat(
                    "linkscript"));
                Process process;
                if (file.exists())

                {
                    //process = Runtime.getRuntime().exec(
                    //    "sh " + file.toString() + " " + getScriptParameter());
                    process = Runtime.getRuntime().exec("sh " + file.toString());
                    try
                    {
                        process.waitFor();
                    }
                    catch(InterruptedException e)
                    {
                        Log.writelog(e.getMessage());
                    }
                }
            }
            catch(IOException e)
            {
                Log.writelog(e);
            }
        }
    }

    /**
     * MSRtfĹ
     */
    private void replaceStrForFileLink()
    {
        String clName = "file:".concat(installPath.concat("/Mimelnk/fileAssociate.jar"));
        try
        {//debug 300728
            boolean isUOF = false;
            if (idata.getAppVersion().contains("ZH") || idata.getAppVersion().contains("JA"))
            {
                isUOF = true;
            }
            URLClassLoader cl = new URLClassLoader(new URL[]{new URL(clName)});
            Method method = cl.loadClass("FileAssociate").getMethod("installLink",
                new Class[]{boolean.class, boolean.class, boolean.class});
            method.invoke("installLink", new Object[]{Boolean.valueOf(msCheckSelected),
                Boolean.valueOf(rtfCheckSelected), Boolean.valueOf(isUOF)});
        }
        catch(Exception ex)
        {
            Log.writelog("installing when file associate, yield exception");
        }
    }

    /*private String getScriptParameter()
     {
     String iconAssociationPath = "/usr/share/icons/default/index.theme";
     if (new File(iconAssociationPath).exists())
     {
     ParseIniFile parseFile = new ParseIniFile(iconAssociationPath, ParseIniFile.NO_CHARSET);
     parseFile.readIniFile();
     String defaultIconPath = parseFile.getValue("Icon Theme", "Inherits");
     return defaultIconPath;
     }
     return "";
     }*/

    /***************************************************************************
     * ȫ°װʱ windows :װʹnativeĿ¼,ens.dlleioXpackĿ¼Setup.exeguidĿ¼
     * linuxҪ
     */
    public void copyNativeFiles()
    {
        String nativeDir = DisposeData.getCurrentPath().concat(File.separator).concat("native");
        if (OsVersion.IS_WINDOWS)
        {
            File srcFile = new File(nativeDir);

            Log.writelog("begin to copy native files to GUID directory!");

            File dstFile = new File(idata.getVariable(ScriptParser.EIOXPACK_GUID_DIR), "native");
            if (!dstFile.exists())
            {
                if (!dstFile.mkdir())
                {
                    Log.writelog("create dir " + dstFile.getAbsolutePath() + "failed!");
                    return;
                }
            }
            IoHelper.copyDir(srcFile, dstFile);
        }

        // setupļguid
        String setup = (OsVersion.IS_WINDOWS) ? "setup.exe" : "setup";
        File setupFrom = new File(DisposeData.getCurrentPath(), setup);
        File setupTo = new File(idata.getVariable(ScriptParser.EIOXPACK_GUID_DIR), setup);
        try
        {
            if (setupFrom.exists())
                IoHelper.copyFile(setupFrom, setupTo, "755");
        }
        catch(IOException e1)
        {
            Log.writelog(e1);
        }

        //linuxsetup.shguid.
        File scriptFrom = new File(DisposeData.getCurrentPath(), "setup.sh");
        File scriptTo = new File(idata.getVariable(ScriptParser.EIOXPACK_GUID_DIR), "setup.sh");
        try
        {
            if (OsVersion.IS_LINUX && scriptFrom.exists())
                IoHelper.copyFile(scriptFrom, scriptTo, "755");
        }
        catch(IOException e1)
        {
            Log.writelog(e1);
        }

        // ⿽eins.dlleioXpack
        if (OsVersion.IS_WINDOWS)
        {
            File eioXpack = new File(idata.getVariable(ScriptParser.EIOXPACK_GUID_DIR))
                .getParentFile();

            File einsDllFrom = new File(nativeDir, "eins.dll");
            File einsDllTo = new File(eioXpack.getAbsolutePath(), "eins.dll");
            try
            {
                IoHelper.copyFile(einsDllFrom, einsDllTo);
            }
            catch(IOException e)
            {
                Log.writelog(e);
            }
        }
    }

    /**
     * ԴGUIDȫ°װʱô˷
     * 
     */
    public void copyInstDataToGUID()
    {
        File instDataFrom = new File(DisposeData.getCurrentPath(), SharedAttr.INSTDATA);
        File instDataTo = new File(idata.getVariable(ScriptParser.EIOXPACK_GUID_DIR),
            SharedAttr.INSTDATA);
        IoHelper.copyDir(instDataFrom, instDataTo);
    }

    /**
     * ƽűGUIDĿ¼ʹÿ޸޸ġװʱ޸İװĿ¼еȨޡ
     *
     */
    public void copyScriptToGUID()
    {
        try
        {
            if (!OsVersion.IS_WINDOWS)
            {
                File scriptFrom = new File(DisposeData.getCurrentPath().concat(File.separator)
                    .concat("linkscript"));
                if (scriptFrom.exists())
                {
                    File scriptTo = new File(idata.getVariable(ScriptParser.EIOXPACK_GUID_DIR)
                        .concat(File.separator).concat("linkscript"));
                    if (scriptFrom.exists())
                    {
                        IoHelper.copyFile(scriptFrom, scriptTo);
                    }
                }
            }
        }
        catch(IOException e)
        {
            Log.writelog(e);
        }
    }

    public void copyInstallInfoToGUID()
    {
        try
        {
            File scriptFrom = new File(DisposeData.getCurrentPath().concat(File.separator).concat(
                "InstallInfo.ini"));
            if (scriptFrom.exists())
            {
                File scriptTo = new File(idata.getVariable(ScriptParser.EIOXPACK_GUID_DIR).concat(
                    File.separator).concat("InstallInfo.ini"));
                IoHelper.copyFile(scriptFrom, scriptTo);
            }
        }
        catch(IOException e)
        {
            Log.writelog(e);
        }
    }

    public void copyPicToInstallPath()
    {
        try
        {
            File startPic, picTo;
            if (OsVersion.IS_WINDOWS)
            {
                startPic = new File(DisposeData.getCurrentPath().concat(File.separator).concat(
                    "start.bmp"));
                picTo = new File(installPath.concat(File.separator).concat("System").concat(
                    File.separator).concat("start.bmp"));
            }
            else
            {
                startPic = new File(DisposeData.getCurrentPath().concat(File.separator).concat(
                    "start.jpg"));
                picTo = new File(installPath.concat(File.separator).concat("System").concat(
                    File.separator).concat("start.jpg"));
            }
            if (startPic.exists())
            {
                IoHelper.copyFile(startPic, picTo);
            }
            startPic = new File(DisposeData.getCurrentPath().concat(File.separator).concat(
                "picture.jpg"));
            if (startPic.exists())
            {
                IoHelper.copyFile(startPic, new File(installPath.concat(File.separator).concat(
                    "System").concat(File.separator).concat("picture.jpg")));
            }
        }
        catch(IOException e)
        {
            Log.writelog(e);
        }
    }

    /**
     * EIOReaderװJreȨޡ
     * EIOfficeڽűlinkscript޸JreȨޡ
     */
    public void changeFilePermissions()
    {
        try
        {
            File jre = new File(installPath.concat(File.separator).concat("Jre"));
            Process process;
            if (jre.exists())
            {
                process = Runtime.getRuntime().exec("chmod -R 777 " + jre);
                process.waitFor();
            }
        }
        catch(Exception e)
        {
            Log.writelog(e);
        }
    }

    private void replaceStrForCups()
    {
        try
        {
            // linuxϵͳļ       
            File cupsFile = new File("/etc/cups/cupsd.conf");
            //滻ַ
            String beReplaceString = "Listen /var/run/cups/cups.sock";

            if (cupsFile.exists())
            {
                BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(
                    cupsFile)));
                String l;
                StringBuffer sb = new StringBuffer();
                while ((l = in.readLine()) != null)
                {
                    sb.append(l);
                    sb.append("\n");
                }
                in.close();

                String txt = sb.toString();

                if (txt.contains(beReplaceString) && !txt.contains("#" + beReplaceString))
                {
                    txt = txt.replaceAll(beReplaceString, "#" + beReplaceString);
                }

                BufferedWriter out = new BufferedWriter(new OutputStreamWriter(
                    new FileOutputStream(cupsFile)));
                out.write(txt);
                out.close();
            }
        }
        catch(IOException e)
        {
            Log.writelog(e);
        }
    }

    private String buildPersonTag()
    {
        String str = "";
        String id = "";
        NumberFormat form = NumberFormat.getInstance();
        Random r = new Random();
        for (int i = 0; i < 10; i++)
        {
            str = form.format(r.nextInt());
            id += str.substring(str.length() - 1);
        }
        String releaseName = OsVersion.getReleaseName();
        return "L".concat(releaseName).concat("_").concat(id);
    }
}
